Index: c/Actions/hello.cpp
===================================================================
--- src/Actions/hello.cpp	(revision dd0f1b1e1a9125755de73d4edd0d787f21f7d5c6)
+++ 	(revision )
@@ -1,151 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010 University of Bonn. All rights reserved.
- * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
- */
-
-/*
- * hello.cpp
- *
- *  Created on: Sep 20, 2011
- *      Author: heber
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include <boost/python.hpp>
-
-#include "CodePatterns/MemDebug.hpp"
-
-#include <iostream>
-#include <map>
-#include <string>
-
-#include "CodePatterns/Registry.hpp"
-#include "CodePatterns/Singleton.hpp"
-
-#include "CodePatterns/Singleton_impl.hpp"
-#include "CodePatterns/Registry_impl.hpp"
-
-class Atrait;
-
-class Otrait
-{
-public:
-  Otrait(const std::string &_text) : text(_text) {}
-  ~Otrait() {}
-  const std::string & getName() const { return text; }
-private:
-  std::string text;
-};
-
-class Atrait : public Otrait
-{
-public:
-  Atrait() : Otrait(std::string("Atrait")) 
-  {
-    options.insert( std::make_pair ( "AOtrait", new Otrait("AOtrait") ) );
-  }
-  Atrait(const Atrait &trait) : Otrait(trait) 
-  {
-    for (Omap::const_iterator iter = trait.options.begin(); iter != trait.options.end(); ++iter)
-      options.insert( std::make_pair ( "copied AOtrait", new Otrait(*(iter->second)) ) );
-  }
-  ~Atrait() 
-  {
-    for (Omap::iterator iter = options.begin(); iter != options.end(); ++iter)
-      delete iter->second;
-    options.clear();
-  }
-private:
-  typedef std::map<std::string, Otrait * > Omap;
-
-  Omap options;
-};
-
-class Action
-{
-public:
-  Action(const Atrait &_trait) : trait(_trait) {}
-  ~Action() {}
-
-  const char * greet() { return "hello, this is MoleCuilder."; }
-
-  const std::string & getName() const { return trait.getName(); }
-
-  const Atrait trait;
-private:
-};
-
-
-/** Action Registry.
- *
- * The Action registry is a storage for any Action instance to retrieved by name.
- * It is a singleton and can be called from anywhere.
- *
- */
-class ActionRegistry : public Singleton<ActionRegistry>, public Registry<Action>
-{
-  friend class Singleton<ActionRegistry>;
-  //friend class Registry<Action>;
-
-public:
-  Action* getActionByName(const std::string name);
-  void fillRegistry();
-
-private:
-  ActionRegistry();
-  ~ActionRegistry();
-};
-
-/** Constructor for class ActionRegistry.
- */
-ActionRegistry::ActionRegistry()
-{
-  std::cout << "ActionRegistry::ActionRegistry() called, instance is " << this << "." << std::endl;
-  fillRegistry();
-}
-
-void ActionRegistry::fillRegistry()
-{
-  Action *presentAction = NULL;
-  {
-    Atrait atrait;
-    presentAction = new Action(atrait);
-    registerInstance(presentAction);
-  }
-  std::cout << "presentAction instance is " << presentAction << "." << std::endl;
-}
-
-
-/** Destructor for class ActionRegistry.
- */
-ActionRegistry::~ActionRegistry()
-{
-  std::cout << "ActionRegistry::~ActionRegistry() called, instance is " << this << "." << std::endl;
-  cleanup();
-}
-
-/** Just passes on call to Registry<Action>::getByName().
- * \param name name of Action
- * \return pointer to Action
- */
-Action* ActionRegistry::getActionByName(const std::string name)
-{
-  return getByName(name);
-}
-
-
-char const* greet()
-{
-  return ActionRegistry::getInstance().getActionByName("Atrait")->greet();
-}
-
-BOOST_PYTHON_MODULE(Pythontest)
-{
-    boost::python::def("greet", greet);
-}
Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision dd0f1b1e1a9125755de73d4edd0d787f21f7d5c6)
+++ src/Makefile.am	(revision 12facf18b09b4648333e0fe89c03343bc34892d3)
@@ -261,12 +261,4 @@
 molecuilder_DATA = Element/elements.db Element/valence.db Element/orbitals.db Element/Hbonddistance.db Element/Hbondangle.db
 
-pyexec_LTLIBRARIES += Pythontest.la
-Pythontest_la_SOURCES = Actions/hello.cpp
-Pythontest_la_CPPFLAGS = $(AM_CPPFLAGS) ${CodePatterns_CFLAGS} -I$(PYTHON_INCLUDE_DIR)
-Pythontest_la_LDFLAGS = -module -avoid-version -shared
-Pythontest_la_LIBADD = \
-	$(BOOST_PYTHON_LDFLAGS) $(BOOST_PYTHON_LIBS) \
-	${CodePatterns_LIBS} \
-	-l$(PYTHON_LIB)
 
 pyexec_LTLIBRARIES += pyMoleCuilder.la
Index: tests/regression/Makefile.am
===================================================================
--- tests/regression/Makefile.am	(revision dd0f1b1e1a9125755de73d4edd0d787f21f7d5c6)
+++ tests/regression/Makefile.am	(revision 12facf18b09b4648333e0fe89c03343bc34892d3)
@@ -132,5 +132,4 @@
 	$(srcdir)/Python/BoxMaker/testsuite-python-boxmaker.at \
 	$(srcdir)/Python/CommandHelp/testsuite-python-commandhelp.at \
-	$(srcdir)/Python/Pythontest/testsuite-python-pythontest.at \
 	$(srcdir)/Python/ReturnValueActions/testsuite-python-returnvalueactions.at \
 	$(srcdir)/RandomNumbers/testsuite-randomnumbers.at \
Index: sts/regression/Python/Pythontest/testsuite-python-pythontest.at
===================================================================
--- tests/regression/Python/Pythontest/testsuite-python-pythontest.at	(revision dd0f1b1e1a9125755de73d4edd0d787f21f7d5c6)
+++ 	(revision )
@@ -1,11 +1,0 @@
-# simple test module with a single greet() function
-
-AT_SETUP([Python externalization - Simple hello])
-AT_KEYWORDS([python])
-AT_DATA([pythontest.py], [[
-import Pythontest
-print Pythontest.greet()
-]])
-AT_CHECK([../../Python/run pythontest.py], 0, [stdout], [ignore])
-AT_CHECK([fgrep "hello, this is MoleCuilder." stdout], 0, [ignore], [ignore])
-AT_CLEANUP
Index: tests/regression/Python/testsuite-python.at
===================================================================
--- tests/regression/Python/testsuite-python.at	(revision dd0f1b1e1a9125755de73d4edd0d787f21f7d5c6)
+++ tests/regression/Python/testsuite-python.at	(revision 12facf18b09b4648333e0fe89c03343bc34892d3)
@@ -1,6 +1,3 @@
 AT_BANNER([MoleCuilder - Python externalization])
-
-# simple test module with a single greet() function
-m4_include([Python/Pythontest/testsuite-python-pythontest.at])
 
 # CommandHelp