Index: src/LinearAlgebra/Makefile.am
===================================================================
--- src/LinearAlgebra/Makefile.am	(revision 6d5a104a348d8b5b9e69f59a022509811fb750cc)
+++ src/LinearAlgebra/Makefile.am	(revision 13d1504cb6c549a18c96fb24463172b5f411e4c2)
@@ -12,4 +12,5 @@
   ${HELPERSOURCE} \
   BoxVector.cpp \
+  leastsquaremin.cpp \
   Line.cpp \
   LineSegment.cpp \
@@ -27,4 +28,5 @@
 LINALGHEADER = \
   BoxVector.hpp \
+  leastsquaremin.hpp \
   Line.hpp \
   LineSegment.hpp \
Index: src/LinearAlgebra/leastsquaremin.cpp
===================================================================
--- src/LinearAlgebra/leastsquaremin.cpp	(revision 13d1504cb6c549a18c96fb24463172b5f411e4c2)
+++ src/LinearAlgebra/leastsquaremin.cpp	(revision 13d1504cb6c549a18c96fb24463172b5f411e4c2)
@@ -0,0 +1,46 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * leastsquaremin.cpp
+ *
+ *  Created on: Aug 18, 2009
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include <iostream>
+
+#include "LinearAlgebra/leastsquaremin.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+/** Determines sum of squared distances of \a X to all \a **vectors.
+ * \param *x reference vector
+ * \param *params
+ * \return sum of square distances
+ */
+double LSQ (const gsl_vector * const x, void * params)
+{
+  double sum = 0.;
+  struct LSQ_params *par = (struct LSQ_params *)params;
+  const Vector ** vectors = par->vectors;
+  int num = par->num;
+
+  for (int i=num;i--;) {
+    for(int j=NDIM;j--;)
+      sum += (gsl_vector_get(x,j) - (vectors[i])->at(j))*(gsl_vector_get(x,j) - (vectors[i])->at(j));
+  }
+
+  return sum;
+};
+
Index: src/LinearAlgebra/leastsquaremin.hpp
===================================================================
--- src/LinearAlgebra/leastsquaremin.hpp	(revision 13d1504cb6c549a18c96fb24463172b5f411e4c2)
+++ src/LinearAlgebra/leastsquaremin.hpp	(revision 13d1504cb6c549a18c96fb24463172b5f411e4c2)
@@ -0,0 +1,49 @@
+/*
+ * leastsquaremin.hpp
+ *
+ *  Created on: Aug 18, 2009
+ *      Author: heber
+ */
+
+#ifndef LEASTSQUAREMIN_HPP_
+#define LEASTSQUAREMIN_HPP_
+
+using namespace std;
+
+/*********************************************** includes ***********************************/
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <gsl/gsl_vector.h>
+
+/****************************************** forward declarations *****************************/
+
+class element;
+class molecule;
+class Vector;
+
+/********************************************** declarations *******************************/
+
+/** Parameter structure for least square minimsation.
+ */
+struct LSQ_params {
+  const Vector **vectors;
+  int num;
+};
+
+double LSQ(const gsl_vector * const x, void * params);
+
+/** Parameter structure for least square minimsation.
+ */
+struct lsq_params {
+  gsl_vector *x;
+  const molecule *mol;
+  const element *type;
+};
+
+
+
+#endif /* LEASTSQUAREMIN_HPP_ */
Index: src/LinearAlgebra/vector_ops.cpp
===================================================================
--- src/LinearAlgebra/vector_ops.cpp	(revision 6d5a104a348d8b5b9e69f59a022509811fb750cc)
+++ src/LinearAlgebra/vector_ops.cpp	(revision 13d1504cb6c549a18c96fb24463172b5f411e4c2)
@@ -20,13 +20,13 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "LinearAlgebra/Vector.hpp"
-#include "LinearAlgebra/Plane.hpp"
+#include "Exceptions/LinearDependenceException.hpp"
+#include "Exceptions/SkewException.hpp"
+#include "Helpers/fast_functions.hpp"
+#include "Helpers/Info.hpp"
 #include "Helpers/Log.hpp"
 #include "Helpers/Verbose.hpp"
-#include "leastsquaremin.hpp"
-#include "Helpers/Info.hpp"
-#include "Helpers/fast_functions.hpp"
-#include "Exceptions/LinearDependenceException.hpp"
-#include "Exceptions/SkewException.hpp"
+#include "LinearAlgebra/leastsquaremin.hpp"
+#include "LinearAlgebra/Plane.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 #include <gsl/gsl_linalg.h>
Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision 6d5a104a348d8b5b9e69f59a022509811fb750cc)
+++ src/Makefile.am	(revision 13d1504cb6c549a18c96fb24463172b5f411e4c2)
@@ -169,5 +169,4 @@
   Formula.cpp \
   graph.cpp \
-  leastsquaremin.cpp \
   linkedcell.cpp \
   moleculelist.cpp \
@@ -205,5 +204,4 @@
   Formula.hpp \
   graph.hpp \
-  leastsquaremin.hpp \
   linkedcell.hpp \
   lists.hpp \
Index: c/leastsquaremin.cpp
===================================================================
--- src/leastsquaremin.cpp	(revision 6d5a104a348d8b5b9e69f59a022509811fb750cc)
+++ 	(revision )
@@ -1,46 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010 University of Bonn. All rights reserved.
- * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
- */
-
-/*
- * leastsquaremin.cpp
- *
- *  Created on: Aug 18, 2009
- *      Author: heber
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include "Helpers/MemDebug.hpp"
-
-#include <iostream>
-
-#include "leastsquaremin.hpp"
-#include "LinearAlgebra/Vector.hpp"
-
-/** Determines sum of squared distances of \a X to all \a **vectors.
- * \param *x reference vector
- * \param *params
- * \return sum of square distances
- */
-double LSQ (const gsl_vector * const x, void * params)
-{
-  double sum = 0.;
-  struct LSQ_params *par = (struct LSQ_params *)params;
-  const Vector ** vectors = par->vectors;
-  int num = par->num;
-
-  for (int i=num;i--;) {
-    for(int j=NDIM;j--;)
-      sum += (gsl_vector_get(x,j) - (vectors[i])->at(j))*(gsl_vector_get(x,j) - (vectors[i])->at(j));
-  }
-
-  return sum;
-};
-
Index: c/leastsquaremin.hpp
===================================================================
--- src/leastsquaremin.hpp	(revision 6d5a104a348d8b5b9e69f59a022509811fb750cc)
+++ 	(revision )
@@ -1,49 +1,0 @@
-/*
- * leastsquaremin.hpp
- *
- *  Created on: Aug 18, 2009
- *      Author: heber
- */
-
-#ifndef LEASTSQUAREMIN_HPP_
-#define LEASTSQUAREMIN_HPP_
-
-using namespace std;
-
-/*********************************************** includes ***********************************/
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include <gsl/gsl_vector.h>
-
-/****************************************** forward declarations *****************************/
-
-class element;
-class molecule;
-class Vector;
-
-/********************************************** declarations *******************************/
-
-/** Parameter structure for least square minimsation.
- */
-struct LSQ_params {
-  const Vector **vectors;
-  int num;
-};
-
-double LSQ(const gsl_vector * const x, void * params);
-
-/** Parameter structure for least square minimsation.
- */
-struct lsq_params {
-  gsl_vector *x;
-  const molecule *mol;
-  const element *type;
-};
-
-
-
-#endif /* LEASTSQUAREMIN_HPP_ */
Index: src/molecule.cpp
===================================================================
--- src/molecule.cpp	(revision 6d5a104a348d8b5b9e69f59a022509811fb750cc)
+++ src/molecule.cpp	(revision 13d1504cb6c549a18c96fb24463172b5f411e4c2)
@@ -33,5 +33,5 @@
 #include "graph.hpp"
 #include "Helpers/helpers.hpp"
-#include "leastsquaremin.hpp"
+#include "LinearAlgebra/leastsquaremin.hpp"
 #include "linkedcell.hpp"
 #include "lists.hpp"
Index: src/molecule_geometry.cpp
===================================================================
--- src/molecule_geometry.cpp	(revision 6d5a104a348d8b5b9e69f59a022509811fb750cc)
+++ src/molecule_geometry.cpp	(revision 13d1504cb6c549a18c96fb24463172b5f411e4c2)
@@ -31,5 +31,5 @@
 #include "config.hpp"
 #include "element.hpp"
-#include "leastsquaremin.hpp"
+#include "LinearAlgebra/leastsquaremin.hpp"
 #include "molecule.hpp"
 #include "World.hpp"