Index: tests/regression/Potential/FitPotential/pre/lj_homology.dat
===================================================================
--- tests/regression/Potential/FitPotential/pre/lj_homology.dat	(revision f5724f5e9fef76b193afb7727d363143bd251f59)
+++ tests/regression/Potential/FitPotential/pre/lj_homology.dat	(revision 16c6f7843f246e0e7ac0521b380137a10e710076)
@@ -1,272 +1,2 @@
-22 serialization::archive 9 1 0
-0 0 0 90 0 0 0 1 0
-1 0 0 1 0 0 0 1 0
-2 18 0 1 0 0 0 0 0 1 1 0
-3 0 0 1 0 0 0 3 0 0 0 0 18 -526.80098113869781 0
-4 1 0
-5 18 0 1 0 0
-6 1 0 3 0 7.7478765531735849 0 0 18 -526.80098113869781 0
-7 1 0
-8 18 0 1 0 0
-9 1 0 3 0 0 0 0 18 -526.80098113869781 0
-10 1 0
-11 18 0 1 0 0
-12 1 0 3 0 7.9629084734139814 0 0 18 -526.8009811386994 0
-13 1 0
-14 18 0 1 0 0
-15 1 0 3 0 0 0 0 18 -526.80098113869781 0
-16 1 0
-17 18 0 1 0 0
-18 1 0 3 0 8.1779592909142629 0 0 18 -526.80098113869781 0
-19 1 0
-20 18 0 1 0 0
-21 1 0 3 0 0 0 0 18 -526.80098113869781 0
-22 1 0
-23 18 0 1 0 0
-24 1 0 3 0 8.3929912111546567 0 0 18 -526.80098113869974 0
-25 1 0
-26 18 0 1 0 0
-27 1 0 3 0 0 0 0 18 -526.80098113869781 0
-28 1 0
-29 18 0 1 0 0
-30 1 0 3 0 8.6080231313950542 0 0 18 -526.80098113869792 0
-31 1 0
-32 18 0 1 0 0
-33 1 0 3 0 0 0 0 18 -526.80098113869781 0
-34 1 0
-35 18 0 1 0 0
-36 1 0 3 0 8.8230739488953347 0 0 18 -526.80098113869667 0
-37 1 0
-38 18 0 1 0 0
-39 1 0 3 0 0 0 0 18 -526.80098113869781 0
-40 1 0
-41 18 0 1 0 0
-42 1 0 3 0 9.0381058691357303 0 0 18 -526.8009811386986 0
-43 1 0
-44 18 0 1 0 0
-45 1 0 3 0 0 0 0 18 -526.80098113869781 0
-46 1 0
-47 18 0 1 0 0
-48 1 0 3 0 9.2531377893761277 0 0 18 -526.80098113869985 0
-49 1 0
-50 18 0 1 0 0
-51 1 0 3 0 0 0 0 18 -526.80098113869781 0
-52 1 0
-53 18 0 1 0 0
-54 1 0 3 0 9.4681697096165234 0 0 18 -526.80098113869906 0
-55 1 0
-56 18 0 1 0 0
-57 1 0 3 0 0 0 0 18 -526.80098113869781 0
-58 1 0
-59 18 0 1 0 0
-60 1 0 3 0 9.6832205271168039 0 0 18 -526.80098113869826 0
-61 1 0
-62 18 0 1 0 0
-63 1 0 3 0 0 0 0 18 -526.80098113869781 0
-64 1 0
-65 18 0 1 0 0
-66 1 0 3 0 9.8982524473571996 0 0 18 -526.80098113869883 0
-67 1 0
-68 18 0 1 0 0
-69 1 0 3 0 0 0 0 18 -526.80098113869781 0
-70 1 0
-71 18 0 1 0 0
-72 1 0 3 0 10.113284367597595 0 0 18 -526.80098113869735 0
-73 1 0
-74 18 0 1 0 0
-75 1 0 3 0 0 0 0 18 -526.80098113869781 0
-76 1 0
-77 18 0 1 0 0
-78 1 0 3 0 10.328335185097876 0 0 18 -526.8009811386986 0
-79 1 0
-80 18 0 1 0 0
-81 1 0 3 0 0 0 0 18 -526.80098113869781 0
-82 1 0
-83 18 0 1 0 0
-84 1 0 3 0 10.543367105338273 0 0 18 -526.80098113869906 0
-85 1 0
-86 18 0 1 0 0
-87 1 0 3 0 0 0 0 18 -526.80098113869781 0
-88 1 0
-89 18 0 1 0 0
-90 1 0 3 0 10.758399025578669 0 0 18 -526.80098113869656 0
-91 1 0
-92 18 0 1 0 0
-93 1 0 3 0 0 0 0 18 -526.80098113869781 0
-94 1 0
-95 18 0 1 0 0
-96 1 0 3 0 10.973449843078949 0 0 18 -526.80098113869838 0
-97 1 0
-98 18 0 1 0 0
-99 1 0 3 0 0 0 0 18 -526.80098113869781 0
-100 1 0
-101 18 0 1 0 0
-102 1 0 3 0 11.188481763319345 0 0 18 -526.80098113869838 0
-103 1 0
-104 18 0 1 0 0
-105 1 0 3 0 0 0 0 18 -526.80098113869781 0
-106 1 0
-107 18 0 1 0 0
-108 1 0 3 0 11.403513683559741 0 0 18 -526.80098113869826 0
-109 1 0
-110 18 0 1 0 0
-111 1 0 3 0 0 0 0 18 -526.80098113869781 0
-112 1 0
-113 18 0 1 0 0
-114 1 0 3 0 11.618564501060021 0 0 18 -526.80098113869769 0
-115 1 0
-116 18 0 1 0 0
-117 1 0 3 0 0 0 0 18 -526.80098113869781 0
-118 1 0
-119 18 0 1 0 0
-120 1 0 3 0 11.833596421300417 0 0 18 -526.80098113869724 0
-121 1 0
-122 18 0 1 0 0
-123 1 0 3 0 0 0 0 18 -526.80098113869781 0
-124 1 0
-125 18 0 1 0 0
-126 1 0 3 0 12.048628341540814 0 0 18 -526.80098113869815 0
-127 1 0
-128 18 0 1 0 0
-129 1 0 3 0 0 0 0 18 -526.80098113869781 0
-130 1 0
-131 18 0 1 0 0
-132 1 0 3 0 12.263679159041095 0 0 18 -526.80098113869838 0
-133 1 0
-134 18 0 1 0 0
-135 1 0 3 0 0 0 0 18 -526.80098113869781 0
-136 1 0
-137 18 0 1 0 0
-138 1 0 3 0 12.47871107928149 0 0 18 -526.80098113869906 0
-139 1 0
-140 18 0 1 0 0
-141 1 0 3 0 0 0 0 18 -526.80098113869781 0
-142 1 0
-143 18 0 1 0 0
-144 1 0 3 0 12.693742999521888 0 0 18 -526.80098113869781 0
-145 1 0
-146 18 0 1 0 0
-147 1 0 3 0 0 0 0 18 -526.80098113869781 0
-148 1 0
-149 18 0 1 0 0
-150 1 0 3 0 12.908774919762282 0 0 18 -526.80098113869792 0
-151 1 0
-152 18 0 1 0 0
-153 1 0 3 0 0 0 0 18 -526.80098113869781 0
-154 1 0
-155 18 0 1 0 0
-156 1 0 3 0 13.123825737262562 0 0 18 -526.80098113869792 0
-157 1 0
-158 18 0 1 0 0
-159 1 0 3 0 0 0 0 18 -526.80098113869781 0
-160 1 0
-161 18 0 1 0 0
-162 1 0 3 0 13.33885765750296 0 0 18 -526.80098113869781 0
-163 1 0
-164 18 0 1 0 0
-165 1 0 3 0 0 0 0 18 -526.80098113869781 0
-166 1 0
-167 18 0 1 0 0
-168 1 0 3 0 13.553889577743355 0 0 18 -526.80098113869849 0
-169 1 0
-170 18 0 1 0 0
-171 1 0 3 0 0 0 0 18 -526.80098113869781 0
-172 1 0
-173 18 0 1 0 0
-174 1 0 3 0 13.768940395243636 0 0 18 -526.80098113869872 0
-175 1 0
-176 18 0 1 0 0
-177 1 0 3 0 0 0 0 18 -526.80098113869781 0
-178 1 0
-179 18 0 1 0 0
-180 1 0 3 0 13.983972315484033 0 0 18 -526.80098113869849 0
-181 1 0
-182 18 0 2 0 0
-183 2 0 3 0 0 0 0 18 3 0 7.7478765531735849 0 0 18 6.6946925244337763e-05 0
-184 1 0
-185 18 0 2 0 0
-186 2 0 3 0 0 0 0 18 3 0 7.9629084734139814 0 0 18 3.1313933277488104e-05 0
-187 1 0
-188 18 0 2 0 0
-189 2 0 3 0 0 0 0 18 3 0 8.1779592909142629 0 0 18 1.00932477380411e-05 0
-190 1 0
-191 18 0 2 0 0
-192 2 0 3 0 0 0 0 18 3 0 8.3929912111546567 0 0 18 -2.003853637688735e-06 0
-193 1 0
-194 18 0 2 0 0
-195 2 0 3 0 0 0 0 18 3 0 8.6080231313950542 0 0 18 -8.5344285025712452e-06 0
-196 1 0
-197 18 0 2 0 0
-198 2 0 3 0 0 0 0 18 3 0 8.8230739488953347 0 0 18 -1.1774555332522141e-05 0
-199 1 0
-200 18 0 2 0 0
-201 2 0 3 0 0 0 0 18 3 0 9.0381058691357303 0 0 18 -1.3102843809065234e-05 0
-202 1 0
-203 18 0 2 0 0
-204 2 0 3 0 0 0 0 18 3 0 9.2531377893761277 0 0 18 -1.3313790759639232e-05 0
-205 1 0
-206 18 0 2 0 0
-207 2 0 3 0 0 0 0 18 3 0 9.4681697096165234 0 0 18 -1.2852214581471344e-05 0
-208 1 0
-209 18 0 2 0 0
-210 2 0 3 0 0 0 0 18 3 0 9.6832205271168039 0 0 18 -1.1973692835454131e-05 0
-211 1 0
-212 18 0 2 0 0
-213 2 0 3 0 0 0 0 18 3 0 9.8982524473571996 0 0 18 -1.0840870231731969e-05 0
-214 1 0
-215 18 0 2 0 0
-216 2 0 3 0 0 0 0 18 3 0 10.113284367597595 0 0 18 -9.5718712600501021e-06 0
-217 1 0
-218 18 0 2 0 0
-219 2 0 3 0 0 0 0 18 3 0 10.328335185097876 0 0 18 -8.2603543205550523e-06 0
-220 1 0
-221 18 0 2 0 0
-222 2 0 3 0 0 0 0 18 3 0 10.543367105338273 0 0 18 -6.9811050025236909e-06 0
-223 1 0
-224 18 0 2 0 0
-225 2 0 3 0 0 0 0 18 3 0 10.758399025578669 0 0 18 -5.7894145584214129e-06 0
-226 1 0
-227 18 0 2 0 0
-228 2 0 3 0 0 0 0 18 3 0 10.973449843078949 0 0 18 -4.7213208063112688e-06 0
-229 1 0
-230 18 0 2 0 0
-231 2 0 3 0 0 0 0 18 3 0 11.188481763319345 0 0 18 -3.7954163190079271e-06 0
-232 1 0
-233 18 0 2 0 0
-234 2 0 3 0 0 0 0 18 3 0 11.403513683559741 0 0 18 -3.0152962153806584e-06 0
-235 1 0
-236 18 0 2 0 0
-237 2 0 3 0 0 0 0 18 3 0 11.618564501060021 0 0 18 -2.3738474510537344e-06 0
-238 1 0
-239 18 0 2 0 0
-240 2 0 3 0 0 0 0 18 3 0 11.833596421300417 0 0 18 -1.8572890212453785e-06 0
-241 1 0
-242 18 0 2 0 0
-243 2 0 3 0 0 0 0 18 3 0 12.048628341540814 0 0 18 -1.4482508277069428e-06 0
-244 1 0
-245 18 0 2 0 0
-246 2 0 3 0 0 0 0 18 3 0 12.263679159041095 0 0 18 -1.1285741265965044e-06 0
-247 1 0
-248 18 0 2 0 0
-249 2 0 3 0 0 0 0 18 3 0 12.47871107928149 0 0 18 -8.8109061380237108e-07 0
-250 1 0
-251 18 0 2 0 0
-252 2 0 3 0 0 0 0 18 3 0 12.693742999521888 0 0 18 -6.9050815909577068e-07 0
-253 1 0
-254 18 0 2 0 0
-255 2 0 3 0 0 0 0 18 3 0 12.908774919762282 0 0 18 -5.4393251502915518e-07 0
-256 1 0
-257 18 0 2 0 0
-258 2 0 3 0 0 0 0 18 3 0 13.123825737262562 0 0 18 -4.3090642520837719e-07 0
-259 1 0
-260 18 0 2 0 0
-261 2 0 3 0 0 0 0 18 3 0 13.33885765750296 0 0 18 -3.4324193620705046e-07 0
-262 1 0
-263 18 0 2 0 0
-264 2 0 3 0 0 0 0 18 3 0 13.553889577743355 0 0 18 -2.7465625862532761e-07 0
-265 1 0
-266 18 0 2 0 0
-267 2 0 3 0 0 0 0 18 3 0 13.768940395243636 0 0 18 -2.2044491743145045e-07 0
-268 1 0
-269 18 0 2 0 0
-270 2 0 3 0 0 0 0 18 3 0 13.983972315484033 0 0 18 -1.7716956790536642e-07 0
+22 serialization::archive 10 1 0
+0 0 0 30 0 0 0 0 0 0 0 1 0 0 0 0 0 18 0 1 0 0 0 0 0 1 0 0 0 0 1 0 0 0 3 0 0 0 0 0 0 18 18 -526.80662623029025 0 1 0 18 0 1 0 0 1 0 3 0 7.7478765531735849 0 0 18 18 -526.80662623029082 0 1 0 18 0 1 0 0 1 0 3 0 0 0 0 18 18 -526.80662623029025 0 1 0 18 0 1 0 0 1 0 3 0 8.3714861294046301 0 0 18 18 -526.80662623029127 0 1 0 18 0 1 0 0 1 0 3 0 0 0 0 18 18 -526.80662623029025 0 1 0 18 0 1 0 0 1 0 3 0 8.9950957056356735 0 0 18 18 -526.80662623028979 0 1 0 18 0 1 0 0 1 0 3 0 0 0 0 18 18 -526.80662623029025 0 1 0 18 0 1 0 0 1 0 3 0 9.6187052818667187 0 0 18 18 -526.80662623029139 0 1 0 18 0 1 0 0 1 0 3 0 0 0 0 18 18 -526.80662623029025 0 1 0 18 0 1 0 0 1 0 3 0 10.242314858097764 0 0 18 18 -526.80662623029059 0 1 0 18 0 1 0 0 1 0 3 0 0 0 0 18 18 -526.80662623029025 0 1 0 18 0 1 0 0 1 0 3 0 10.865924434328809 0 0 18 18 -526.80662623029036 0 1 0 18 0 1 0 0 1 0 3 0 0 0 0 18 18 -526.80662623029025 0 1 0 18 0 1 0 0 1 0 3 0 11.489534010559854 0 0 18 18 -526.80662623029139 0 1 0 18 0 1 0 0 1 0 3 0 0 0 0 18 18 -526.80662623029025 0 1 0 18 0 1 0 0 1 0 3 0 12.113143586790898 0 0 18 18 -526.80662623029139 0 1 0 18 0 1 0 0 1 0 3 0 0 0 0 18 18 -526.80662623029025 0 1 0 18 0 1 0 0 1 0 3 0 12.736753163021943 0 0 18 18 -526.80662623029127 0 1 0 18 0 1 0 0 1 0 3 0 0 0 0 18 18 -526.80662623029025 0 1 0 18 0 1 0 0 1 0 3 0 13.360362739252988 0 0 18 18 -526.80662623029093 0 1 0 18 0 2 0 0 2 0 3 0 0 0 0 18 18 3 0 7.7478765531735849 0 0 18 18 8.0644011745789612e-05 0 1 0 18 0 2 0 0 2 0 3 0 0 0 0 18 18 3 0 8.3714861294046301 0 0 18 18 1.0775948680930014e-05 0 1 0 18 0 2 0 0 2 0 3 0 0 0 0 18 18 3 0 8.9950957056356735 0 0 18 18 -4.3589745928329648e-06 0 1 0 18 0 2 0 0 2 0 3 0 0 0 0 18 18 3 0 9.6187052818667187 0 0 18 18 -4.7124892716965405e-06 0 1 0 18 0 2 0 0 2 0 3 0 0 0 0 18 18 3 0 10.242314858097764 0 0 18 18 -2.4768916091488791e-06 0 1 0 18 0 2 0 0 2 0 3 0 0 0 0 18 18 3 0 10.865924434328809 0 0 18 18 -9.3296910108620068e-07 0 1 0 18 0 2 0 0 2 0 3 0 0 0 0 18 18 3 0 11.489534010559854 0 0 18 18 -2.7415171643951908e-07 0 1 0 18 0 2 0 0 2 0 3 0 0 0 0 18 18 3 0 12.113143586790898 0 0 18 18 -6.5251015257672407e-08 0 1 0 18 0 2 0 0 2 0 3 0 0 0 0 18 18 3 0 12.736753163021943 0 0 18 18 -1.2863552001363132e-08 0 1 0 18 0 2 0 0 2 0 3 0 0 0 0 18 18 3 0 13.360362739252988 0 0 18 18 -2.1361756807891652e-09 0